
const {ccclass, property} = cc._decorator;

@ccclass
export default class Box extends cc.Component {

    @property(cc.Node)
    nodeCamera: cc.Node = null;

    @property(cc.Node)
    nodeBox: cc.Node = null;

    @property(cc.Node)
    nodeMyBox: cc.Node = null;

    curPage = 0;
    rotationDir = 0;
    totalDegree = 0;

    // ba = [[], [5, 6, 4, 2], [5, 6, 1, 3], [5, 6, 2, 4], []];

    // LIFE-CYCLE CALLBACKS:

    onLoad () {
        this.nodeBox.active = false;
    }

    start () {

    }

    update (dt) {
        if(!this.rotationDir) return;
        let v3 = this.nodeMyBox.eulerAngles;
        console.log("##", v3)
        // let out: cc.Quat = new cc.Quat();
        // let curQuad = new cc.Quat(0, 0, 0, 1);
        // (this.nodeMyBox as any).getWorldRotation(out);
        let degree = dt * 90;
        this.totalDegree += degree;
        if(this.totalDegree > 90) {
            degree -= this.totalDegree - 90;
        }
        // let radius = degree * Math.PI / 360;
        if(this.rotationDir == 1) {
            v3.x += degree;
            // curQuad.x = Math.sin(radius);
            // curQuad.w = Math.cos(radius);
        }
        else if(this.rotationDir == 2) {
            v3.x -= degree;
            // curQuad.x = Math.sin(-radius);
            // curQuad.w = Math.cos(-radius);
        }
        else if(this.rotationDir == 3) {
            v3.y += degree;
            // curQuad.y = Math.sin(radius);
            // curQuad.w = Math.cos(radius);
        }
        else if(this.rotationDir == 4) {
            v3.y -= degree;
            // curQuad.y = Math.sin(-radius);
            // curQuad.w = Math.cos(-radius);
        }
        else if(this.rotationDir == 5) {
            v3.z -= degree;
        }
        else if(this.rotationDir == 6) {
            v3.z += degree;
        }
        this.nodeMyBox.eulerAngles = v3;
        // curQuad = curQuad.fromEuler(v3);
        // console.log(curQuad)
        if(this.totalDegree >= 90) {
            this.rotationDir = 0;
            this.totalDegree = 0;
            
        }
        // let quat = new cc.Quat(0, 0, 0, 1);
        // quat.w = out.w * curQuad.w - out.x * curQuad.x - out.y * curQuad.y - out.z * curQuad.z;
        // quat.x = out.w * curQuad.x + out.x * curQuad.w + out.y * curQuad.z - out.z * curQuad.y;
        // quat.y = out.w * curQuad.y - out.x * curQuad.z + out.y * curQuad.w + out.z * curQuad.x;
        // quat.z = out.w * curQuad.z + out.x * curQuad.y - out.y * curQuad.x + out.z * curQuad.w;
        // (this.nodeMyBox as any).setWorldRotation(quat);
        // this.nodeMyBox.eulerAngles = this.nodeMyBox.eulerAngles;
        console.log("degree=" + degree + ", dir=" + this.rotationDir)
        console.log(v3)
    }

    onClickUp() {
        console.log("click up, ", this.nodeMyBox.eulerAngles);
        // this.nodeMyBox.eulerAngles = new cc.Vec3(0, -90, -90);
        // return;
        // let quat = new cc.Quat(Math.sqrt(0.5), 0, 0, Math.sqrt(0.5));
        // (this.nodeMyBox as any).setWorldRotation(quat);
        // this.nodeMyBox.eulerAngles = this.nodeMyBox.eulerAngles;
        // return;
        // let out: any = {};
        // console.log((this.nodeMyBox as any).getWorldRotation(out))
        if(this.rotationDir) return;
        if(Math.abs(this.nodeMyBox.eulerAngles.y) < 1 && Math.abs(Math.abs(this.nodeMyBox.eulerAngles.y) - 180) < 1)
         this.rotationDir = 1;
        else this.rotationDir = 5;
        return;
        this.nodeMyBox.runAction(cc.rotate3DBy(1, 90));
        console.log(this.nodeMyBox.eulerAngles);
    }

    onClickDown() {
        console.log("click down, ", this.nodeMyBox.eulerAngles);
        if(this.rotationDir) return;
        // if(Math.abs(this.nodeMyBox.eulerAngles.y) < 1 && Math.abs(Math.abs(this.nodeMyBox.eulerAngles.y) - 180) < 1) 
        this.rotationDir = 2;
        // else this.rotationDir = 6;
        return;
        this.nodeMyBox.runAction(cc.rotate3DBy(1, -90));
        console.log(this.nodeMyBox.eulerAngles);
    }

    onClickLeft() {
        console.log("click left, ", this.nodeMyBox.eulerAngles)
        if(this.rotationDir) return;
        this.rotationDir = 3;
        return;
        this.nodeMyBox.runAction(cc.rotate3DBy(1, 0, 90));
        console.log(this.nodeMyBox.eulerAngles);
    }

    onClickRight() {
        console.log("click right, ", this.nodeMyBox.eulerAngles)
        if(this.rotationDir) return;
        this.rotationDir = 4;
        return;
        this.nodeMyBox.runAction(cc.rotate3DBy(1, 0, -90));
        console.log(this.nodeMyBox.eulerAngles);
    }
}
